Bug 506389 - Moose requires Test::Builder (which pulls in perl-devel)
Moose requires Test::Builder (which pulls in perl-devel)
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: perl-Moose (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Chris Weyl
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-17 00:15 EDT by Iain Arnell
Modified: 2009-06-23 02:15 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-06-23 02:15:37 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Iain Arnell 2009-06-17 00:15:05 EDT
Test::Moose in the perl-Moose package pulls in perl-devel + deps. It would be nice to avoid that on runtime systems.


Version-Release number of selected component (if applicable):
perl-Moose-0.81-1.fc12.noarch


Steps to Reproduce:
1. yum install perl-Moose
  
Actual results:
installs perl-devel + deps

Expected results:
doesn't install perl-devel + deps

Additional info:
Can we split Test::Moose into a separate sub-package?
Comment 1 Chris Weyl 2009-06-18 11:11:36 EDT
Hmmm... yeah, this should be looked at.  My initial concern with splitting it off is that I'm not sure how many (or even if any) packages have this as a "silent" test requires.
Comment 2 Iain Arnell 2009-06-20 06:43:27 EDT
That's easy enough to check. repoquery, cvs, find, make prep, and grep turn up 41 packages that require perl(Moose), of which 8 also silently require Test::Moose.

perl-DBIx-Class
perl-Moose
perl-MooseX-AttributeHelpers
perl-MooseX-Daemonize
perl-MooseX-Getopt
perl-MooseX-POE
perl-MooseX-Role-Parameterized
perl-MooseX-Types

BTW, perl-MooseX-Daemonize suffers the same problem - it contains Test::MouseX::Daemonize that also brings in perl-devel et al.

If only we had rpm with soft-dependencies - perl-Test-Moose BuildSupplements perl-Moose (assuming koji/mock would respect strong soft-deps).
Comment 3 Chris Weyl 2009-06-23 02:15:37 EDT
Oof, yeah.  I've been wanting soft-deps for ages for reasons along these lines...

Ok, so I've done the split and committed/built it in rawhide.  The packages soft-requiring it we'll have to add it manually *sigh* unless the package maintainers add it as a test_requires (which given how many of them use Module::Install should be trivial for them to do).

I've also filed bugs in rt for the ones above (RT::Client::REST can be _very_ useful) -- except for Moose itself, of course -- so hopefully we'll be seeing test_requires metadata on them soon.  I also didn't file one against DBIx::Class as they're still considering Moose to be a "soft" requires.  RT#47258 to 63.

I'm marking this CLOSED/RAWHIDE; we'll get it out to F-11/10, but not until we're through the current mass-Moose updates, at least.

Note You need to log in before you can comment on or make changes to this bug.